<?xml version="1.0"?> 
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <xsl:output method="text" indent="yes" />

<!--  enumtc.xsl
        Rick Landau, Dell, 20070307
        From Projector&Display Mgt WG XML for mgt group properties, 
        extract a fragment of SNMP MIB syntax. 
        
        In this case, make a TC for every enumerated integer.  
        -->

  <xsl:variable name="SNMPprefix">pdm</xsl:variable>
  <xsl:variable name="SNMPPrefix">Pdm</xsl:variable>

<!-- G r o u p -->
  <xsl:template match="Group">
<!--    - seen:Group <xsl:value-of select="@name"/>\n -->
    -- Processed by enumtc07.xsl at    .  .  . <!-- <xsl:value-of select="fn:current-dateTime()"/> -->
    <xsl:apply-templates select="Property">
      <xsl:with-param name="GroupName"><xsl:value-of select="@GroupName"/></xsl:with-param>
    </xsl:apply-templates>
    <xsl:apply-templates select="Table">
      <xsl:with-param name="GroupName"><xsl:value-of select="@GroupName"/></xsl:with-param>
    </xsl:apply-templates>
  </xsl:template>
  
<!-- T a b l e -->
  <xsl:template name="Table" match="Table">
    <xsl:param name="GroupName"/>
<!--   - seen:Table <xsl:value-of select="@TableName"/> -->
    <xsl:apply-templates select="Property">
      <xsl:with-param name="GroupName"><xsl:value-of select="$GroupName"/></xsl:with-param>
      <xsl:with-param name="TableName"><xsl:value-of select="@TableName"/></xsl:with-param>
    </xsl:apply-templates>
  </xsl:template>

<!-- P r o p e r t y -->
  <xsl:template name="Property" match="Property">
    <xsl:param name="GroupName"/>
    <xsl:param name="TableName"/>
<!--    - Property at-AbstractName=<xsl:value-of select="@AbstractName"/> -->
<!--    - parent is type=<xsl:value-of select="name(..)"/> -->
<!--    - Property in table at-TableName=<xsl:value-of select="../@TableName"/> -->
<!--    - Property in group at-name=<xsl:value-of select="../../@name"/> -->
    <xsl:variable name="mypartnameis">
      <xsl:choose>
        <xsl:when test="contains(SNMPName,' ')">
          <xsl:value-of select="$GroupName"/>
          <xsl:value-of select="@AbstractName"/>
        </xsl:when>
        <xsl:otherwise><xsl:value-of select="SNMPName" /></xsl:otherwise>
      </xsl:choose> 
    </xsl:variable>
<!--    - Property will be   $SNMPprefix + $mypartnameis -->
<!--    - TC name, however, has capitalized prefix, so use $SNMPPrefix and $mypartnameis -->
<!--    - Datatype is <xsl:value-of select="./Datatype/@Type" />\n -->
    <xsl:apply-templates select="Datatype">
      <xsl:with-param name="PartPropertyName"><xsl:value-of select="$mypartnameis"/></xsl:with-param>
    </xsl:apply-templates>
  </xsl:template>

<!-- D a t a t y p e -->
  <xsl:template match="Datatype">
  <xsl:param name="PartPropertyName"/>
<!--    - seen:Datatype <xsl:value-of select="@Type"/> -->
    <xsl:if test="@Type='EnumeratedInteger'">
<xsl:text>
</xsl:text>
<xsl:value-of select="$SNMPPrefix"/><xsl:value-of select="$PartPropertyName"/>TC ::= TEXTUAL-CONVENTION
    STATUS  current
    DESCRIPTION 
        <xsl:text>"</xsl:text>TC for enumerated property <xsl:value-of select="$SNMPprefix"/><xsl:value-of select="$PartPropertyName" />.<xsl:text>"</xsl:text>
    SYNTAX INTEGER {
    <xsl:apply-templates select=".//Value"/>
    }
    </xsl:if>
  </xsl:template>

<!-- V a l u e -->
  <xsl:template match="Value">
<!--    - seen:Value=|<xsl:value-of select="normalize-space(.)"/>|<xsl:value-of select="@Number"/>| -->
        <xsl:text>  </xsl:text>
        <xsl:variable name="step1"><xsl:value-of select="normalize-space(.)"/></xsl:variable>
        <xsl:variable name="step2"><xsl:value-of select="$step1"/></xsl:variable>
        <xsl:value-of select="$step2"/>(<xsl:value-of select="@Number"/>)<xsl:if test="not(position()=last())">,
    </xsl:if>
  </xsl:template>

</xsl:stylesheet>

<!--
Edit history:
20070307    RBL v02 Original usable version.
20070909    RBL v04 Changed naming and formatting
                    per comments from Ira McDonald on proper SNMP
                    structure.
20070910    RBL v05 Fix formatting for improved legibility.  
20071031    RBL v06 Capitalize TC name, harder than it should have been.  
20071116    RBL v07 Capitalize INTEGER.  

-->
