#!/usr/bin/perl
# fixup-insertgroupnumbers.pl
#                   RBLandau 20070918
#
use English; 
use newtrace;

my $sPrefix = "pdm";

defined($ARGV[2-1]) || die "Usage: fixup  grouporder-file  mib-file\n";

# Get group numbers
newtrace::trace( 1,"file1=|$ARGV[1-1]|");
open( GROUPS, "<", $ARGV[1-1] ) || die "Error: cannot open grouporder file $ARGV[1-1]";

while (<GROUPS>)
{
    $sLine = $_;
    $sGroupName = "";
    next if /^\s*$/;
    next if /^\s*#/;
    ($sGroupName,$sGroupNumber) = $sLine =~ /^(\S+)\s+(\d+)\s*$/;
    if ($sGroupName)
    {
        $sFullName = $sPrefix . $sGroupName;
        $hGroups{$sFullName} = $sGroupNumber;
    } else
    {
        die "Error: syntax error in line |$sLine|\n";
    }
    newtrace::trace(3,"fullname|$sFullName|=|$sGroupNumber|");
}

# Now the MIB file
newtrace::trace( 1,"file2=|$ARGV[2-1]|");
open( MIB,  '<', $ARGV[2-1] ) || die "Error: cannot open CSV file $ARGV[2-1]";
newtrace::trace(3,"");

# Process the MIB file line by line.
# For all lines that appear to be assigning a group number, 
#  substitute the number from the the group-number file, 
#  if there is one; if not, then issue a warning.  
while (<MIB>)
{
    $sLine = $_;
    $sOidName = "";
    ($sOidName,$sOidRoot) = $sLine =~
/\s*([-a-zA-Z0-9]+)\s+OBJECT\s+IDENTIFIER\s+::=\s+{\s*([-a-zA-Z0-9]+)\s+inserthere-index\s*}/;
    if ( $sOidName )
    {
        newtrace::trace(1,"proc  oid assignment to|$sOidName| from root|$sOidRoot| line $NR");
        if ( $nGroupNum = $hGroups{$sOidName} )
        {
            # It's a group OID assignment for a group we know.
            newtrace::trace(3,"proc  oid|$sOidName| group number|$nGroupNum|");
            my $sLeft = "";
            ($sLeft,$sMid,$sRight) = $sLine =~ /^(.+)(inserthere-index)(.+)$/;
            if ($sLeft)
            {
                $sLineOut = $sLeft . $hGroups{$sOidName} . $sRight;
                print "$sLineOut\n";
            }
            
        } else
        {
            # Looks like a group assignment, but for a mystery group.
            print "--" . $sLine; 
            print "Error: unknown group declaration |$sOidName|\n";
        }
        print "\n";
    }
    else
    {
        # Not a group assignment, some other statement.  
        print; 
    }
}
